#include <stdio.h>
#include <stdarg.h>
#include <string.h>

static void
output (void *ptr, int c)
{
  fputc (c, ptr);
}

int
vfprintf (FILE *f, const char *format, va_list ap)
{
  extern int _vxprintf (void (*) (void *, int), void *, const char *, va_list);
  return _vxprintf (output, f, format, ap);
}

#if 0
static int
pd (FILE *f, unsigned x)
{
  const char *s = "0123456789";
  int n;

  if (x == 0)
    return 0;

  n = pd (f, x / 10U);
  fputc (s[x % 10U], f);
  return n + 1;
}

static int
printd (FILE *f, int x)
{
  int n = 0;

  if (x == 0)
    {
      fputc ('0', f);
      return 1;
    }

  if (x < 0)
    {
      fputc ('-', f);
      x = -x;
      n++;
    }

  return n + pd (f, x);
}

static int
printo (FILE *f, int x)
{
  int i, n = 0;
  for (i = 0; i < 12; i++)
    {
      char *s = "01234567";
      fputc (s[(x >> 33) & 7], f);
      n++;
      x <<= 3;
    }
  return n;
}

int
vfprintf (FILE *f, const char *format, va_list ap)
{
  int n = 0;

  for (; *format; format++)
    {
      if (*format != '%')
	fputc (*format, f);
      else
	{
	  int x;

	  for (format++; ; format++)
	    switch (*format)
	      {
	      case '%':
		fputc ('%', f);
		goto done;
	      case 'c':
		x = va_arg (ap, char);
		fputc (x, f);
		n++;
		goto done;
	      case 's':
		{
		  char *s = va_arg (ap, char *);
		  fputs (s, f);
		  n += strlen (s);
		  goto done;
		}
	      case 'o':
		x = va_arg (ap, int);
		n += printo (f, x);
		goto done;
	      case 'd':
		x = va_arg (ap, int);
		n += printd (f, x);
		goto done;
	      case 'u':
		x = va_arg (ap, int);
		if (x != 0)
		  n += pd (f, x);
		else
		  {
		    fputc ('0', f);
		    n++;
		  }
		goto done;
	      case 'x':
	      case 'X':
	      case 'f':
	      case 'g':
		fputs ("<something>", f);
		goto done;
	      }
	done:
	  ;
	}
    }

  return n;
}
#endif
